
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Webhook_deliveriesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const webhook_deliveries = await db.webhook_deliveries.create(
            {
                id: data.id || undefined,
        
        event_type: data.event_type
        ||
        null
            ,
            
        event_reference: data.event_reference
        ||
        null
            ,
            
        delivered_at: data.delivered_at
        ||
        null
            ,
            
        delivery_status: data.delivery_status
        ||
        null
            ,
            
        http_status: data.http_status
        ||
        null
            ,
            
        request_payload: data.request_payload
        ||
        null
            ,
            
        response_body: data.response_body
        ||
        null
            ,
            
        attempt_count: data.attempt_count
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await webhook_deliveries.setEndpoint( data.endpoint || null, {
            transaction,
        });
        
        await webhook_deliveries.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return webhook_deliveries;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const webhook_deliveriesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                event_type: item.event_type
            ||
            null
            ,
            
                event_reference: item.event_reference
            ||
            null
            ,
            
                delivered_at: item.delivered_at
            ||
            null
            ,
            
                delivery_status: item.delivery_status
            ||
            null
            ,
            
                http_status: item.http_status
            ||
            null
            ,
            
                request_payload: item.request_payload
            ||
            null
            ,
            
                response_body: item.response_body
            ||
            null
            ,
            
                attempt_count: item.attempt_count
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const webhook_deliveries = await db.webhook_deliveries.bulkCreate(webhook_deliveriesData, { transaction });

        // For each item created, replace relation files
        

        return webhook_deliveries;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const webhook_deliveries = await db.webhook_deliveries.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.event_type !== undefined) updatePayload.event_type = data.event_type;
        
        
        if (data.event_reference !== undefined) updatePayload.event_reference = data.event_reference;
        
        
        if (data.delivered_at !== undefined) updatePayload.delivered_at = data.delivered_at;
        
        
        if (data.delivery_status !== undefined) updatePayload.delivery_status = data.delivery_status;
        
        
        if (data.http_status !== undefined) updatePayload.http_status = data.http_status;
        
        
        if (data.request_payload !== undefined) updatePayload.request_payload = data.request_payload;
        
        
        if (data.response_body !== undefined) updatePayload.response_body = data.response_body;
        
        
        if (data.attempt_count !== undefined) updatePayload.attempt_count = data.attempt_count;
        
        
        updatePayload.updatedById = currentUser.id;

        await webhook_deliveries.update(updatePayload, {transaction});

        
        
        if (data.endpoint !== undefined) {
            await webhook_deliveries.setEndpoint(
              
              data.endpoint,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await webhook_deliveries.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return webhook_deliveries;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const webhook_deliveries = await db.webhook_deliveries.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of webhook_deliveries) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of webhook_deliveries) {
                await record.destroy({transaction});
            }
        });


        return webhook_deliveries;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const webhook_deliveries = await db.webhook_deliveries.findByPk(id, options);

        await webhook_deliveries.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await webhook_deliveries.destroy({
            transaction
        });

        return webhook_deliveries;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const webhook_deliveries = await db.webhook_deliveries.findOne(
            { where },
            { transaction },
        );

        if (!webhook_deliveries) {
            return webhook_deliveries;
        }

        const output = webhook_deliveries.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.endpoint = await webhook_deliveries.getEndpoint({
            transaction
        });
        
        
        output.organizations = await webhook_deliveries.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.webhook_endpoints,
        as: 'endpoint',
        
        where: filter.endpoint ? {
          [Op.or]: [
            { id: { [Op.in]: filter.endpoint.split('|').map(term => Utils.uuid(term)) } },
            {
              endpoint_name: {
                [Op.or]: filter.endpoint.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.event_type) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'webhook_deliveries',
                        'event_type',
                        filter.event_type,
                    ),
                };
            }
            
            if (filter.event_reference) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'webhook_deliveries',
                        'event_reference',
                        filter.event_reference,
                    ),
                };
            }
            
            if (filter.request_payload) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'webhook_deliveries',
                        'request_payload',
                        filter.request_payload,
                    ),
                };
            }
            
            if (filter.response_body) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'webhook_deliveries',
                        'response_body',
                        filter.response_body,
                    ),
                };
            }
            

            
            

            
            if (filter.delivered_atRange) {
                const [start, end] = filter.delivered_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    delivered_at: {
                    ...where.delivered_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    delivered_at: {
                    ...where.delivered_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.http_statusRange) {
                const [start, end] = filter.http_statusRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    http_status: {
                    ...where.http_status,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    http_status: {
                    ...where.http_status,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.attempt_countRange) {
                const [start, end] = filter.attempt_countRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    attempt_count: {
                    ...where.attempt_count,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    attempt_count: {
                    ...where.attempt_count,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.delivery_status) {
                where = {
                    ...where,
                delivery_status: filter.delivery_status,
            };
            }
            


      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.webhook_deliveries.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'webhook_deliveries',
                        'event_type',
                        query,
                    ),
                ],
            };
        }

        const records = await db.webhook_deliveries.findAll({
            attributes: [ 'id', 'event_type' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['event_type', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.event_type,
        }));
    }

    
};

